
 
$(document).ready(  function() {

    //Defino el lenguaje por default
    idioma_cambiar(IDIOMA_DEFAULT);
    
 
    //traigo la lista de regalos posibles
    $(".regalos").load(WS_PATH+"tipos-de-regalos-"+  sessionStorage.getItem("idioma")+".html");
    



    $(document).on('click', '#english',function(){
        //traigo la lista de regalos posibles
        $(".regalos").load(WS_PATH+"tipos-de-regalos-en.html");
    });    

    // Cambio a espaol
    $(document).on('click', '#espanol',function(){
        //traigo la lista de regalos posibles
        $(".regalos").load(WS_PATH+"tipos-de-regalos-es.html");
    });    




    // cargo dias, mes, ao
    $(new Option("DD")).appendTo('#cmb_dia');
    for (var i=1;i<32;i++) $(new Option(i,i)).appendTo('#cmb_dia');

    $(new Option("MM")).appendTo('#cmb_mes');
    for (var i=1;i<13;i++) $(new Option(i,i)).appendTo('#cmb_mes');

    $(new Option("YYYY")).appendTo('#cmb_ano');
    fecha = new Date();
    var hasta = fecha.getFullYear();  var desde = hasta-120;
    for (var i=desde ;i<hasta;i++) $(new Option(i,i)).appendTo('#cmb_ano');


    if (navigator.geolocation) navigator.geolocation.getCurrentPosition(ubicacion_obtener);
     

    $('.submit-loading').hide();

    // Click del boton submit
    $(document).on('click', 'div.submit',function(){

        // paso a la validacion
        $("form").submit();
    });    


    // Valido el form
    
    $('form').validate({
        errorPlacement: function(error, element) { },
        rules: {
                txt_nombre: {required:true  },
                txt_email_papa: {required:true ,email:true },
                cmb_ano:        {required: true, number:true, min:1},
                cmb_mes:        {required: true, number:true, min:1},
                cmb_dia:        {required: true, number:true, min:1},
    
        },
        messages: {
                txt_nombre: '',
                txt_email_papa: '',
                cmb_ano: '',
                cmb_mes: '',
                cmb_dia: '',
        }
        , invalidHandler: function(form, validator) {
                $('.submit-loading').hide();
                $('.submit').show();
                //alert( (sessionStorage.getItem("idioma") == "es" ? "Estabas tan impaciente que te olvidaste de completar algunos campos!" : "You were so anxious that forget to complete some fields!") );
                $("#txt_nombre").focus();
                
        }
        , submitHandler: function(form) {
                $('.submit-loading').show();
                $('.submit').hide();
                
                
                //alert ("Falta validar q complete algun producto y el loading cambiarlo.");
                
                // Envio el formulario
                var formData = new FormData(form);

                // Make the ajax call
                $.ajax({
                    url: WS_PATH+"enviar-regalos-a-papa-noel-"+  sessionStorage.getItem("idioma")  +".html",
                    type: 'POST',
                    xhr: function() {
                        var myXhr = $.ajaxSettings.xhr();
                        if(myXhr.upload){
                            myXhr.upload.addEventListener('progress',progress, false);
                        }
                        return myXhr;
                    },
                    //add beforesend handler to validate or something
                    //beforeSend: functionname,
                    success: function (res) {
                        if (res == "ok") {


                                 
                                // Guardo la info 
                                window.localStorage.setItem("ppnoel-nombre", $("#txt_nombre").val());
                                window.localStorage.setItem("ppnoel-email", $("#txt_email_papa").val());
                                window.localStorage.setItem("ppnoel-dia", $("#cmb_dia").val());
                                window.localStorage.setItem("ppnoel-mes", $("#cmb_mes").val());
                                window.localStorage.setItem("ppnoel-ano", $("#cmb_ano").val());
                                
                                
                                

                            if( navigator.userAgent.match(/iPad/i) || navigator.userAgent.match(/iPhone/i) ||  navigator.userAgent.match(/iPod/i)) {
                                window.location="carta-enviada.html";
                            }else{
                                window.location.href="carta-enviada.html";    
                            }
                        
                        }else{
                                $('.submit-loading').hide();
                                $('.submit').show();
                                
                                if (sessionStorage.getItem("idioma") == "es") {
                                    alert("Un reno se metio en el medio y no pudimos enviarle tu carta a pap\u00e1 noel. Reintent\u00e1 la operaci\u00f3n nuevamente por favor");
                                }else{
                                    alert("Some reindeer got into the middle and could not send your letter to Santa Claus. Retry the operation again please");
                                }
                            
                        }
                        
                    },
                    //add error handler for when a error occurs if you want!
                    error: function (){
                        $('.submit-loading').hide();
                        $('.submit').show();
                        
                        if (sessionStorage.getItem("idioma") == "es") {
                            alert("Un reno se metio en el medio y no pudimos enviarle tu carta a pap\u00e1 noel. Reintent\u00e1 la operaci\u00f3n nuevamente por favor");
                        }else{
                            alert("Some reindeer got into the middle and could not send your letter to Santa Claus. Retry the operation again please");
                        }
                    },
                    data: formData,
                    // this is the important stuf you need to overide the usual post behavior
                    cache: false,
                    contentType: false,
                    processData: false
                });                
                return false;
                
        }
    
    });
  
  // ASigno el dispositivo
  $("#txt_dispositivo").val(device.name);
  

    // Si existia la info, la precargo 
    if ((window.localStorage.length !=0) && (window.localStorage.getItem("ppnoel-nombre") != null) && (window.localStorage.getItem("ppnoel-nombre") != "null")) $("#txt_nombre").val(window.localStorage.getItem("ppnoel-nombre"));  
    if ((window.localStorage.length !=0) && (window.localStorage.getItem("ppnoel-email") != null) && (window.localStorage.getItem("ppnoel-email") != "null")) $("#txt_email_papa").val(window.localStorage.getItem("ppnoel-email"));  
    if ((window.localStorage.length !=0) && (window.localStorage.getItem("ppnoel-dia") != null) && (window.localStorage.getItem("ppnoel-dia") != "null")) $("#cmb_dia").val(window.localStorage.getItem("ppnoel-dia"));  
    if ((window.localStorage.length !=0) && (window.localStorage.getItem("ppnoel-mes") != null) && (window.localStorage.getItem("ppnoel-mes") != "null")) $("#cmb_mes").val(window.localStorage.getItem("ppnoel-mes"));  
    if ((window.localStorage.length !=0) && (window.localStorage.getItem("ppnoel-ano") != null) && (window.localStorage.getItem("ppnoel-ano") != "null")) $("#cmb_ano").val(window.localStorage.getItem("ppnoel-ano"));  

});


// Yes outside of the .ready space becouse this is a function not an event listner!
function progress(e){
    if(e.lengthComputable){
        //this makes a nice fancy progress bar
        $('progress').attr({value:e.loaded,max:e.total});
    }
}
 


function ubicacion_obtener(position){
    $("#txt_ubicacion").val(position.coords.latitude + "," + position.coords.longitude);
}
 
