/*  Idioma */

var palabras_en = new Array();
    palabras_en["logo"]     ="images/header/ordertosanta.png";
    palabras_en["idioma"]   ="Lang.";
    palabras_en["envia-tu-carta"] ="Send your letter";
    palabras_en["contacto"] ="Contact";
    palabras_en["mapa"]     ="Letters";

    palabras_en["index-h2"]="Send your letter to Santa!";
    palabras_en["form-nombre"]="Dear Santa, my name's ..";
    palabras_en["form-email-nene"]="My e-mail is:";
    palabras_en["form-email-papa"]="My parent's email is ..";
    palabras_en["form-fecha-nacimiento"]="My birthday is ...";
    palabras_en["form-te-quiero-pedir"]="This year i behave and i would like to recieve..";
    palabras_en["form-submit"]="Send";
    palabras_en["form-subi-carta"]="If you want, send Santa your letter or drawing";
    palabras_en["form-loading"]="Wait.. we're sending to Santa your letter.";
    palabras_en["form-autorizo"]="Yes, I Allow this site to publish my image sent as letter <br />in the Facebook FanPage www.facebook.com/ordertosanta";
    
    palabras_en["volver"]       ="Back";
    //Carta enviada
    palabras_en["carta-enviada-msg"]="Thanks! <b>Santa</b> has recived your letter.<br />Share it!";

    // Contacto
    palabras_en["contacto-nombre"]="My name's ..";
    palabras_en["contacto-email"]="My e-mail is..";
    palabras_en["contacto-msg"]="I want to told you that ..";
    palabras_en["contacto-h1"]="Contact us";
    palabras_en["contacto-gracias"]="Your message has been sent! We'll contact you soon. Thanks";
    palabras_en["contacto-loading"]="Wait.. we're sending your message.";
    
    // Mapa
    palabras_en["mapa-h1"]="Santa has recived 0 letters during ";




var palabras_es = new Array();
    palabras_es["idioma"]   ="Idioma";
    palabras_es["logo"]     ="images/header/pedileapapanoel.png";
    palabras_es["envia-tu-carta"] ="Envi tu carta";
    palabras_es["volver"]   ="Volver";
    palabras_es["contacto"] ="Contacto";
    palabras_es["mapa"]     ="Cartas";

    palabras_es["index-h2"]="Mandale tu cartita a Pap\u00e1 Noel!";
    palabras_es["form-nombre"]="Querido Pap\u00e1 noel, mi nombre es ..";
    palabras_es["form-email-nene"]="Mi e-mail es:";
    palabras_es["form-email-papa"]="El e-mail de mis papas es ...";
    palabras_es["form-fecha-nacimiento"]="Mi cumple es ..";
    palabras_es["form-te-quiero-pedir"]="Este a\u00f1o me porte bien y quiero que me regales...";
    palabras_es["form-subi-carta"]="Si queres, mandale tu cartita o un dibu";
    palabras_es["form-submit"]="Enviar";
    palabras_es["form-loading"]="Aguard&aacute;!... estamos enviandole a Pap&aacute; Noel tu carta.";
    palabras_es["form-autorizo"]="Autorizo a este website a publicar la imagen enviada como mi carta <br />en su FanPage de Facebook: www.facebook.com/pedileapapanoelcom";

    //Carta enviada
    palabras_es["carta-enviada-msg"]="&iexcl;Gracias! <b>Pap&aacute; Noel</b> ya recibi&oacute; tu cartita.<br />Compartilo!";

    // Contacto
    palabras_es["contacto-nombre"]="Mi nombre es ..";
    palabras_es["contacto-email"]="Mi e-mail es..";
    palabras_es["contacto-msg"]="Les quiero decir ..";
    palabras_es["contacto-h1"]="Contactanos";
    palabras_es["contacto-gracias"]="Tu mensaje fue enviado exitosamente. Te estaremos contactando en las proximas horas. Gracias!!";
    palabras_es["contacto-loading"]="Aguarda.. estamos enviando tu mensaje.";


    // Mapa
    palabras_es["mapa-h1"]="Pap&aacute; Noel recibi&oacute; 0 cartitas durante el a&ntilde;o";





$(window).load(function() {
    $(".rslides").responsiveSlides({/*random: true,*/auto: true,speed: 200,nav:false,pauseControls: false,pause: false});
});

$(document).ready(  function() {


    //Si es web, saco el boton de cerrar
    if (ES_WEB) $("ul.idiomas li:last-child").remove();//html("<img src='transparent.gif' width='24'/>") ;


    // Cargo la publiciadad
    $( ".publicidad" ).load( WS_PATH+"publicidades.html");


    // Cambio a ingles
    $(document).on('click', '#english',function(){
        idioma_cambiar("en");

        $("#english").addClass("active");
        $("#espanol").removeClass("active");
    });    

    // Cambio a espaol
    $(document).on('click', '#espanol',function(){
        idioma_cambiar("es");

        $("#espanol").addClass("active");
        $("#english").removeClass("active");
    });    
    

    // Cierro la app
    $(document).on('click', '#cerrar',function(){

            //cierra la app
            sessionStorage.clear();
        
            if (navigator.app && navigator.app.exitApp) {
                navigator.app.exitApp();
            } else if (navigator.device && navigator.device.exitApp) {
                navigator.device.exitApp();
            }
            
    });    
    
    
    
});




 


function idioma_cambiar(idioma){

    
    if (idioma == "") { //lo toma automtico
     
    
        if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)){ //test for MSIE x.x;
            idioma = navigator.userLanguage;    
        }else{
            idioma = window.navigator.language;            
        }
    }
    
    if (idioma == null) idioma = "en";
    if (idioma == "") idioma = "en";
    
    // Guardo localmente
    idioma = idioma.substr(0,2);
    idioma.toLowerCase();
    sessionStorage.setItem("idioma",idioma);
    

    // veo q juego de palabras uso
    var palabras = new Array();
    if (idioma == "es") {
        palabras = palabras_es ;

        $("#espanol").addClass("active");
        $("#english").removeClass("active");
        $(".submit .estrella span").removeClass("ingles");

    }else{
        palabras = palabras_en ;
        $("#espanol").removeClass("active");
        $("#english").addClass("active");
        $(".submit .estrella span").addClass("ingles");
    }
    
    
    // Cambio las palabras
    //$("ul.idiomas li:first-child").text(palabras["idioma"]);
    $("a#envia-tu-carta").text(palabras["envia-tu-carta"]);
    $("a#contacto").text(palabras["contacto"]);
    $("a#mapa").text(palabras["mapa"]);
    $(".logo-letras").removeClass( (idioma == "es" ? "logo-en" : "logo-es") );
    $(".logo-letras").addClass( (idioma == "es" ? "logo-es" : "logo-en") );
    $("a#volver").text(palabras["volver"]);

    // Form        
    $(".subi-carta label").text(palabras["form-subi-carta"]);
    $(".nombre label").text(palabras["form-nombre"]);
    $(".email-nene label").text(palabras["form-email-nene"]);
    $(".email-papa label").text(palabras["form-email-papa"]);
    $(".fecha-nacimiento label").text(palabras["form-fecha-nacimiento"]);
    $(".te-quiero-pedir > label").text(palabras["form-te-quiero-pedir"]);
    $(".submit .estrella span").text(palabras["form-submit"]);
    $(".submit-loading span").html(palabras["form-loading"]);
    $(".autorizo > label").html(palabras["form-autorizo"]);
   
    // Carta enviada msg        
    $("#carta-enviada .msg span").html(palabras["carta-enviada-msg"]);
        

    // contacto        
    $(".contacto-nombre label").html(palabras["contacto-nombre"]);
    $(".contacto-email label").html(palabras["contacto-email"]);
    $(".contacto-mensaje label").html(palabras["contacto-msg"]);
    $("#contacto h1").html(palabras["contacto-h1"]);
    $("#contacto p").html(palabras["contacto-gracias"]);
    $("#contacto .submit-loading span").html(palabras_es["contacto-loading"]);

    // Mapa
    $("#mapa div.carta h2 span").html(palabras["mapa-h1"]);
    $("#index div.carta h2").html(palabras["index-h2"]);
        
}